/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "error.h"

/* 
 * When an error occurs, display a dialog with 
 * the list of errors.
 */
void on_error(GtkObject* cnc) {

  GtkWidget *error_dialog;

  /* Create an error dialog */
  error_dialog = gnome_db_errordlg_new(GDA_CONNECTION(cnc), 
                                       "Database Error");

  /* Display the dialog */
  gtk_window_set_modal(GTK_WINDOW(error_dialog), TRUE);
  gnome_db_errordlg_show_errors(GNOME_DB_ERRORDLG(error_dialog)); 

}

/* 
 * Connect the on_error routine to the connection's error signal.
 */
void register_error_handler(Gda_Connection* cnc) {

  /* If we have a connection error, invoke the 
   * error handler.
   */
  gtk_signal_connect(GTK_OBJECT(cnc),
                     "error", 
                     GTK_SIGNAL_FUNC(on_error), 
                     NULL);
}
